﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Security.Cryptography;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace md5
{
    public partial class Form1 : Form
    {
        public int index = 0;
        public const string strFileName = "FileName";
        public const string strmd5 = "md5";

        public Form1()
        {
            InitializeComponent();
            dataGridView1.Columns.Add(strFileName, "File Name");
            dataGridView1.Columns.Add(strmd5, "md5");
            dataGridView1.Columns[0].Width = Size.Width - 275;
            dataGridView1.Columns[1].Width = 200;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
            if (DialogResult.OK == openFileDialog.ShowDialog())
            {
                if (File.Exists(openFileDialog.FileName.ToString()))
                {
                    string hash= string.Empty;

                    FileStream filestream = new FileStream(openFileDialog.FileName, FileMode.Open);
                    MD5CryptoServiceProvider filemd5 = new MD5CryptoServiceProvider();
                    byte[] buffer = filemd5.ComputeHash(filestream);

                    for (int i = 0; i < buffer.Length; i++)
                        hash += buffer[i].ToString("x2").ToLower();

                    dataGridView1.Rows.Add(1);
                    dataGridView1[strFileName, index].Value = openFileDialog.FileName.ToString();
                    dataGridView1[strmd5, index].Value = hash;
                    index++;
                }
            }
        }

        private void Form1_DragDrop(object sender, DragEventArgs e)
        {
            
            string[] dropanddragfiles = e.Data.GetData(DataFormats.FileDrop) as string[];
            string hash = string.Empty;
            foreach (string s in dropanddragfiles)
            {
                if (File.Exists(s))
                {
                    

                    FileStream filestream = new FileStream(s, FileMode.Open);
                    MD5CryptoServiceProvider filemd5 = new MD5CryptoServiceProvider();
                    byte[] buffer = filemd5.ComputeHash(filestream);

                    for (int i = 0; i < buffer.Length; i++)
                        hash += buffer[i].ToString("x2").ToLower();

                    dataGridView1.Rows.Add();
                    dataGridView1[strFileName, index].Value = s;
                    dataGridView1[strmd5, index].Value = hash;
                    index++;
                    hash = String.Empty;
                    
                }
                //MessageBox.Show(s + Environment.NewLine + "md5 = " + hash);
            }
            

        }

        private void Form1_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop)) e.Effect = DragDropEffects.Copy;
        }

        private void Form1_Resize(object sender, EventArgs e)
        {
            dataGridView1.Columns[0].Width = Size.Width - 275;
            dataGridView1.Columns[1].Width = 200;
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (DialogResult.OK == openFileDialog.ShowDialog())
            {
                if (File.Exists(openFileDialog.FileName.ToString()))
                {
                    string hash = string.Empty;

                    FileStream filestream = new FileStream(openFileDialog.FileName, FileMode.Open);
                    MD5CryptoServiceProvider filemd5 = new MD5CryptoServiceProvider();
                    byte[] buffer = filemd5.ComputeHash(filestream);

                    for (int i = 0; i < buffer.Length; i++)
                        hash += buffer[i].ToString("x2").ToLower();

                    dataGridView1.Rows.Add(1);
                    dataGridView1[strFileName, index].Value = openFileDialog.FileName.ToString();
                    dataGridView1[strmd5, index].Value = hash;
                    index++;
                }
            }
        }

        private void exitToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            this.Dispose();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 aboutbox = new AboutBox1();
            aboutbox.Show();
        }
    }
}
